// ================================================================
// $Id: brdf.h,v 1.6 2005/11/29 15:51:50 xkrivanj Exp $
//
// brdf.h
//     A BRDF in canonical coordinates.
//
// Class:
//     CBRDF
//
// REPLACEMENT_STRING
//
// Initial coding by Jaroslav Krivanek, January 2004

#ifndef __BRDF_H__
#define __BRDF_H__

// SPHAR headers
#include "shconfig.h"

__BEGIN_SPHAR_HEADER

/// This is simple version of BRDF class used to compute the SH 
// representation.
template<class TV,class TA>
class CBRDF
{
public:
  CBRDF() {}
  virtual ~CBRDF() {}

  /// eval in single channel
  virtual TV Eval(const TA* dirIn, const TA *dirOut) const = 0;

  /// eval in multiple channels
  virtual void  EvalCol(TV* col, const TA *dirIn, const TA *dirOut)
    const = 0;
};


/// Implementation of CBRDF for the Phong Lobe
template<class TV,class TA>
class CBRDFPhongLobe : public CBRDF<TV,TA>
{
protected:
  TV _n;

public:
  CBRDFPhongLobe(float shininess) {_n=shininess;}

  inline virtual TV Eval(const TA *L, const TA *V) const;

  virtual void EvalCol(TV* col, const TA *dirIn, const TA *dirOut) const
  { col[0]=col[1]=col[2]=Eval(dirIn,dirOut);}
};

__END_SPHAR_HEADER

#endif // __BRDF_H__

