// ================================================================
// $Id: shconfig.h,v 1.4 2005/11/29 15:51:50 xkrivanj Exp $
/// \file shconfig.h
///
/// \brief This file must be as first included into each 
/// library source (*.h, *.src).
///
/// SPHAR_REPLACEMENT_STRING
///
/// Initial coding by Jaroslav Krivanek, August 2004.

#ifndef __SPHAR_CONFIG_H__
#define __SPHAR_CONFIG_H__

#include <cassert>
#include <iostream>
using namespace std;

#ifdef _MSC_VER
// disable some Microsoft Visual Compiler warnings if necessary
#pragma warning( disable:4244 )
#endif

#ifdef USE_SPHAR_NAMESPACE
#define NAMESPACEDEF  sphar
#define  __BEGIN_SPHAR_SOURCE namespace NAMESPACEDEF { using namespace NAMESPACEDEF;
#define  __END_SPHAR_SOURCE   }
#define  __BEGIN_SPHAR_HEADER namespace NAMESPACEDEF { using namespace NAMESPACEDEF;
#define  __END_SPHAR_HEADER
#else
#define  __BEGIN_SPHAR_SOURCE
#define  __END_SPHAR_SOURCE
#define  __BEGIN_SPHAR_HEADER
#define  __END_SPHAR_HEADER
#endif

/// A very useful macro for debugging purposes.
#ifndef PRINTVAR
#define PRINTVAR(a) DEBUG << #a"\t" << a << std::endl;
#endif

/// Delete a scalar pointer and set it to zero.
#ifndef SAFE_DELETE
#define SAFE_DELETE(p)       { delete   (p); (p)=0;  }
#endif

/// Delete an array pointer and set it to zero.
#ifndef SAFE_DELETE_ARRAY
#define SAFE_DELETE_ARRAY(p) { delete[] (p); (p)=0;  }
#endif

/// Call a method for the given object if the object != 0
#ifndef SAFE_CALL
#define SAFE_CALL(object,method)  { if(object) { (object)->method ; } }
#endif

#ifndef MIN
#define MIN(a,b)  (((a)<(b))?(a):(b))
#endif

#ifndef MAX
#define MAX(a,b)  (((a)>(b))?(a):(b))
#endif

#endif // __SPHAR_CONFIG_H__

