// ===================================================================
// $Id: shlog.h,v 1.3 2005/11/29 15:51:50 xkrivanj Exp $
/// \file shlog.h
/// 
/// \brief Stream names for message logging.
/// 
/// Replace this header by your program's message logging facility if
/// you wish to redirect messages.
/// SPHAR_REPLACEMENT_STRING
/// 
/// Initial coding by Jaroslav Krivanek, August 2004

#ifndef __SHLOG_H__
#define __SHLOG_H__

// SPHAR headers
#include "shconfig.h"

// standard headers
#include <cstdlib>

__BEGIN_SPHAR_HEADER

/// stream for reporting debugging messages
#ifndef DEBUG
#define DEBUG     (std::cerr) << "DEBUG: "
#endif
/// without initial message
#ifndef DEBUGW
#define DEBUGW    (std::cerr)
#endif

/// stream for reporting fatal errors
#ifndef FATAL
#define FATAL     (std::cerr) << "FATAL_ERROR: "
#endif
/// without initial message
#ifndef FATALW
#define FATALW    (std::cerr)
#endif

/// stream for reporting status - what is system doing at the moment
#ifndef STATUS
#define STATUS    (std::cout)
#endif
/// without initial message
#ifndef STATUSW
#define STATUSW   (std::cout)
#endif

/// stream for reporting suspicious states in the input data
#ifndef WARNING
#define WARNING   (std::cerr) << "WARNING: "
#endif
/// without initial message
#ifndef WARNINGW
#define WARNINGW   (std::cerr)
#endif

#if 1
/// program abort with core dump
#ifndef FATAL_ABORT
#define FATAL_ABORT { FATAL << "in the file " << __FILE__ \
  << " , on the line " << __LINE__ << endl; FATALW << flush; abort();}
#endif
#else
// program exit without core dump
#ifndef FATAL_ABORT
#define FATAL_ABORT { FATAL << "in the file " << __FILE__ \
  << " , on the line " << __LINE__ << endl; FATALW << flush; exit(9);}
#endif
#endif

// program exit without core dump
#ifndef FATAL_EXIT
#define FATAL_EXIT {FATAL<<" in the data detected, exiting at file "\
  <<__FILE__<<", on the line "<<__LINE__<<std::endl; FATALW << std::flush; exit(3);}
#endif

__END_SPHAR_HEADER

#endif // __SPHAR_ERRMSG_H__
