// ===================================================================
/// $Id: main.cpp,v 1.4 2004/10/17 00:38:50 xkrivanj Exp $
/// \file main.cpp
/// \brief Code that forces to compile&link the whole SPHRT library.
///
/// SPHAR_REPLACEMENT_STRING
///
/// Initial coding by Jaroslav Krivanek, August 2004.

// SPHAR headers
#include "shconfig.h"
#include "sheval.h"
#include "shrot.h"
#include "shrotmat.h"

#include <stdio.h>

__BEGIN_SPHAR_SOURCE

void svdcmp(float **a, int m, int n, float w[], float **v);


void testeval()
{
  float theta = 0;
  float phi   = 0;
  float x     = 0;
  float y     = 0;
  float z     = 1;
  int   l     = 0;
  int   m     = 0;

  // sheval.cpp
  PRINTVAR( shEvalSph(l,m,theta,phi) );
  PRINTVAR( shEvalCart( l,  m,  x,  y,  z) );
  PRINTVAR( hshEvalSph( l,  m,  theta,  phi) );
  PRINTVAR( hshEvalCart( l,  m,  x,  y,  z) );
  PRINTVAR( assLegendreEval( l, m, x) );
  PRINTVAR( dLegNum( l,  m,  x) );
  PRINTVAR( dLeg( l,  m,  x) );
  PRINTVAR( dSHThetaNum( l,  m,  theta,  phi) );
  PRINTVAR( dSHPhiNum( l,  m,  theta,  phi) );
  PRINTVAR( dSHTheta( l,  m,  theta,  phi) );
  PRINTVAR( dSHPhi( l,  m,  theta,  phi) );
}

void ZeroMatrix(float **A, long nrl, long nrh, long ncl, long nch)
{
  long r,c;
  for(r=nrl; r<=nrh; r++) {
    for(c=ncl; c<=nch; c++) {
      A[r][c] = 0;
    }
  }
}

void IdentityMatrix(float **A, float d, long nrl, long nrh, long ncl, long nch)
{
  long r;
  ZeroMatrix(A,nrl,nrh,ncl,nch);
  for(r=nrl; r<=nrh; r++)
    A[r][r] = d;
}

void PrintMatrix(float **A, long nrl, long nrh, long ncl, long nch)
{
  long r,c;
  for(r=nrl; r<=nrh; r++) {
    for(c=ncl; c<=nch; c++) {
      printf("%.3f\t",A[r][c]);
    }
    printf("\n");
  }
}

void PrintVector(float *V, long nl, long nh)
{
  long i;
  for(i=nl; i<=nh; i++)
      printf("%.3f\t",V[i]);
  printf("\n");
}

long n = 3;

int main(void)
{
  testeval();

  return 0;
}

__END_SPHAR_SOURCE
